/*
 Copyright (C) 2007 by Ben Anderman <ben@happyspork.com>
 Part of Sporktris http://www.happyspork.com/games
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY.
 
 See the License.txt file for more details.
 */

#ifndef HIGHSCORES_H
#define HIGHSCORES_H

#include <vector>
#include <string>

#include "namedv.h"
#include <SDL.h>
#include <SDL_ttf.h>

struct hs_entry
{
	hs_entry (void) : name(""), score(0), level(0), lines(0) {}
	hs_entry (string iName, int iScore, int iLevel, int iLines) : 
		name(iName), score(iScore), level(iLevel), lines(iLines) {}
	string name;
	int score;
	int level;
	int lines;
};

class highscores
{
	static const unsigned int max_scores = 10;
	Namedv *prefs;
	Namedv config;
	string last_name;
	string install_path;
	void sort_scores (void);
	void blit_text (SDL_Surface *surf, TTF_Font *font, const string& text, SDL_Color color, int x=0, bool align_right=false);
	
	public:
	vector<hs_entry> scores;
	highscores (Namedv *iPrefs);
	bool add_score (int score, int level, int lines);
	bool show_scores (int highlight=-1);
	void save_scores (void);
};

#endif
