/*
 Copyright (C) 2007 by Ben Anderman <ben@happyspork.com>
 Part of Sporktris http://www.happyspork.com/games
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY.
 
 See the License.txt file for more details.
 */

#ifndef KEYS_H
#define KEYS_H

#include <map>
#include <string>
#include <SDL.h>

using namespace std;

class Key
{
	bool down;
	unsigned int pressed;
	unsigned int last_event;
	bool done_once;
	
	public:
	string key_name;
	unsigned int delay;
	unsigned int speed;
	Key (void);
	Key (string ikey_name, int idelay, int ispeed);
	bool is_down (void);
	bool get_event (void);
	void reset_state (void);
	void reset_repeat (void);
	void handle_event (SDL_Event *event);
};

class Key_manager
{	
	public:
	map<string, Key> keys;
	void handle_event (SDL_Event *event);
	void add_key (string name, Key k);
	void remove_key (string name);
	void clear (void);
	void reset_state (void);
	void reset_repeat (void);
	Key& operator[] (const string& name);
};

#endif