/*
 Copyright (C) 2007 by Ben Anderman <ben@happyspork.com>
 Part of Sporktris http://www.happyspork.com/games
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY.
 
 See the License.txt file for more details.
 */

#ifndef LAYERS_H
#define LAYERS_H

#include <vector>
#include <string>
#include <SDL.h>

using namespace std;

class layer
{
	public:
	SDL_Surface *surf;
	SDL_Rect rect;
	int x, y;
	bool useClipRect;
	bool changed;
	string name;
	layer (string newName, SDL_Surface *newSurf, int newX, int newY);
	layer (string newName, SDL_Surface *newSurf, int newX, int newY, SDL_Rect newRect);
};

class layerset
{
	public:
	layerset (void);
	bool first;
	vector<layer> layers;
	void add (layer newLayer);
	layer *findByName (string name);
	void blit (SDL_Surface *surf);
};

#endif
