/*
 Copyright (C) 2007 by Ben Anderman <ben@happyspork.com>
 Part of Sporktris http://www.happyspork.com/games
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY.
 
 See the License.txt file for more details.
 */

#ifndef PIECES_H
#define PIECES_H

#include <string>
#include <vector>
using namespace std;

struct block_type
{
	signed char type;
	char level;
	block_type (signed char Type, char Level): type(Type), level(Level) {}
	bool operator== (const block_type& bt) const {return (bt.type == type && bt.level == level);}
	bool operator!= (const block_type& bt) const {return (bt.type != type || bt.level != level);}
	bool operator< (const block_type& bt) const
	{
		return (level < bt.level || (level == bt.level && type < bt.type));
	}
};

class piece
{
	public:
	unsigned short axis_x;
	unsigned short axis_y;
	bool onHalf;
	bool twoPos;
	bool curPos;
	short map[4][2];
	int graphic;
	vector< vector<block_type> > *board;
	short x;
	short y;
	piece (string pSpec, short init_x, short init_y, vector< vector<block_type> > *init_board);
	piece (void);
	piece (const piece& p);
	bool turn (bool direction);
	bool canMove (int xChange, int yChange);
	bool blockOn (int cX, int cY);
	bool checkPos (int cX, int cY);
	short getTop (void);
	string getSpec (void);
	
	void trace (void);
};

#endif
